2015-04-24 21:23:04 +02:00
#!/usr/bin/env bash
2017-03-14 22:31:15 +01:00
## Installer script suitable for osync / obackup / pmocr
2017-03-14 22:33:52 +01:00
PROGRAM = obackup
2017-03-14 22:31:15 +01:00
PROGRAM_VERSION = $( grep "PROGRAM_VERSION=" $PROGRAM .sh)
PROGRAM_VERSION = ${ PROGRAM_VERSION #*= }
2015-11-12 01:26:38 +01:00
PROGRAM_BINARY = $PROGRAM ".sh"
PROGRAM_BATCH = $PROGRAM "-batch.sh"
2017-03-14 22:31:15 +01:00
SSH_FILTER = "ssh_filter.sh"
2018-09-17 11:00:30 +02:00
SCRIPT_BUILD = 2018090301
INSTANCE_ID = " installer- $SCRIPT_BUILD "
2015-04-24 21:23:04 +02:00
2016-04-08 21:09:00 +02:00
## osync / obackup / pmocr / zsnap install script
2017-01-04 09:00:47 +01:00
## Tested on RHEL / CentOS 6 & 7, Fedora 23, Debian 7 & 8, Mint 17 and FreeBSD 8, 10 and 11
2015-04-24 21:23:04 +02:00
## Please adapt this to fit your distro needs
2018-09-17 11:00:30 +02:00
_OFUNCTIONS_BOOTSTRAP = true
2016-11-30 14:04:41 +01:00
# Get current install.sh path from http://stackoverflow.com/a/246128/2635443
SCRIPT_PATH = " $( cd " $( dirname " ${ BASH_SOURCE [0] } " ) " && pwd ) "
2018-07-30 15:36:53 +02:00
_LOGGER_SILENT = false
_STATS = 1
ACTION = "install"
FAKEROOT = ""
function GetCommandlineArguments {
for i in " $@ " ; do
case $i in
--prefix= *)
FAKEROOT = " ${ i ##*= } "
; ;
--silent)
_LOGGER_SILENT = true
; ;
--no-stats)
_STATS = 0
; ;
--remove)
ACTION = "uninstall"
; ;
--help| -h| -?)
Usage
; ;
*)
2018-09-17 11:00:30 +02:00
Logger " Unknown option ' $i ' " "SIMPLE"
2018-07-30 15:36:53 +02:00
Usage
2018-09-17 11:00:30 +02:00
exit
2018-07-30 15:36:53 +02:00
; ;
esac
done
}
GetCommandlineArguments " $@ "
2016-09-08 22:51:24 +02:00
CONF_DIR = $FAKEROOT /etc/$PROGRAM
BIN_DIR = " $FAKEROOT /usr/local/bin "
SERVICE_DIR_INIT = $FAKEROOT /etc/init.d
2016-05-25 00:36:50 +02:00
# Should be /usr/lib/systemd/system, but /lib/systemd/system exists on debian & rhel / fedora
2016-09-08 22:51:24 +02:00
SERVICE_DIR_SYSTEMD_SYSTEM = $FAKEROOT /lib/systemd/system
SERVICE_DIR_SYSTEMD_USER = $FAKEROOT /etc/systemd/user
2018-09-17 11:00:30 +02:00
SERVICE_DIR_OPENRC = $FAKEROOT /etc/init.d
2016-04-08 21:09:00 +02:00
2017-03-14 22:31:15 +01:00
if [ " $PROGRAM " = = "osync" ] ; then
SERVICE_NAME = "osync-srv"
elif [ " $PROGRAM " = = "pmocr" ] ; then
SERVICE_NAME = "pmocr-srv"
fi
2016-04-08 21:09:00 +02:00
2017-03-14 22:31:15 +01:00
SERVICE_FILE_INIT = " $SERVICE_NAME "
SERVICE_FILE_SYSTEMD_SYSTEM = " $SERVICE_NAME @.service "
SERVICE_FILE_SYSTEMD_USER = " $SERVICE_NAME @.service.user "
2018-09-17 11:00:30 +02:00
SERVICE_FILE_OPENRC = " $SERVICE_NAME -openrc "
2016-04-08 21:09:00 +02:00
## Generic code
2015-11-12 01:26:38 +01:00
2016-05-26 11:11:56 +02:00
## Default log file
2017-03-14 22:31:15 +01:00
if [ -w " $FAKEROOT /var/log " ] ; then
2017-01-04 09:00:47 +01:00
LOG_FILE = " $FAKEROOT /var/log/ $PROGRAM -install.log "
2016-05-26 11:11:56 +02:00
elif ( [ " $HOME " != "" ] && [ -w " $HOME " ] ) ; then
2017-01-04 09:00:47 +01:00
LOG_FILE = " $HOME / $PROGRAM -install.log "
2016-05-26 11:11:56 +02:00
else
2017-01-04 09:00:47 +01:00
LOG_FILE = " ./ $PROGRAM -install.log "
2016-03-22 10:56:14 +01:00
fi
2018-09-17 11:00:30 +02:00
#### RemoteLogger SUBSET ####
# Array to string converter, see http://stackoverflow.com/questions/1527049/bash-join-elements-of-an-array
# usage: joinString separaratorChar Array
function joinString {
local IFS = " $1 " ; shift; echo " $* " ;
}
# Sub function of Logger
function _Logger {
local logValue = " ${ 1 } " # Log to file
local stdValue = " ${ 2 } " # Log to screeen
local toStdErr = " ${ 3 :- false } " # Log to stderr instead of stdout
if [ " $logValue " != "" ] ; then
echo -e " $logValue " >> " $LOG_FILE "
# Build current log file for alerts if we have a sufficient environment
if [ " $RUN_DIR / $PROGRAM . ${ FUNCNAME [0] } . $SCRIPT_PID . $TSTAMP " != "" ] ; then
echo -e " $logValue " >> " $RUN_DIR / $PROGRAM . ${ FUNCNAME [0] } . $SCRIPT_PID . $TSTAMP "
fi
fi
if [ " $stdValue " != "" ] && [ " $_LOGGER_SILENT " != true ] ; then
if [ $toStdErr = = true ] ; then
# Force stderr color in subshell
( >& 2 echo -e " $stdValue " )
else
echo -e " $stdValue "
fi
fi
}
# Remote logger similar to below Logger, without log to file and alert flags
function RemoteLogger {
local value = " ${ 1 } " # Sentence to log (in double quotes)
local level = " ${ 2 } " # Log level
local retval = " ${ 3 :- undef } " # optional return value of command
if [ " $_LOGGER_PREFIX " = = "time" ] ; then
prefix = " TIME: $SECONDS - "
elif [ " $_LOGGER_PREFIX " = = "date" ] ; then
prefix = " R $( date) - "
else
prefix = ""
fi
if [ " $level " = = "CRITICAL" ] ; then
_Logger "" " $prefix \e[1;33;41m $value \e[0m " true
if [ $_DEBUG = = "yes" ] ; then
_Logger -e "" " [ $retval ] in [ $( joinString , ${ FUNCNAME [@] } ) ] SP= $SCRIPT_PID P= $$ " true
fi
return
elif [ " $level " = = "ERROR" ] ; then
_Logger "" " $prefix \e[31m $value \e[0m " true
if [ $_DEBUG = = "yes" ] ; then
_Logger -e "" " [ $retval ] in [ $( joinString , ${ FUNCNAME [@] } ) ] SP= $SCRIPT_PID P= $$ " true
fi
return
elif [ " $level " = = "WARN" ] ; then
_Logger "" " $prefix \e[33m $value \e[0m " true
if [ $_DEBUG = = "yes" ] ; then
_Logger -e "" " [ $retval ] in [ $( joinString , ${ FUNCNAME [@] } ) ] SP= $SCRIPT_PID P= $$ " true
fi
return
elif [ " $level " = = "NOTICE" ] ; then
if [ $_LOGGER_ERR_ONLY != true ] ; then
_Logger "" " $prefix $value "
fi
return
elif [ " $level " = = "VERBOSE" ] ; then
if [ $_LOGGER_VERBOSE = = true ] ; then
_Logger "" " $prefix $value "
fi
return
elif [ " $level " = = "ALWAYS" ] ; then
_Logger "" " $prefix $value "
return
elif [ " $level " = = "DEBUG" ] ; then
if [ " $_DEBUG " = = "yes" ] ; then
_Logger "" " $prefix $value "
return
fi
elif [ " $level " = = "PARANOIA_DEBUG" ] ; then #__WITH_PARANOIA_DEBUG
if [ " $_PARANOIA_DEBUG " = = "yes" ] ; then #__WITH_PARANOIA_DEBUG
_Logger "" " $prefix \e[35m $value \e[0m " #__WITH_PARANOIA_DEBUG
return #__WITH_PARANOIA_DEBUG
fi #__WITH_PARANOIA_DEBUG
else
_Logger "" " \e[41mLogger function called without proper loglevel [ $level ].\e[0m " true
_Logger "" " Value was: $prefix $value " true
fi
}
#### RemoteLogger SUBSET END ####
# General log function with log levels:
# Environment variables
# _LOGGER_SILENT: Disables any output to stdout & stderr
# _LOGGER_ERR_ONLY: Disables any output to stdout except for ALWAYS loglevel
# _LOGGER_VERBOSE: Allows VERBOSE loglevel messages to be sent to stdout
# Loglevels
# Except for VERBOSE, all loglevels are ALWAYS sent to log file
# CRITICAL, ERROR, WARN sent to stderr, color depending on level, level also logged
# NOTICE sent to stdout
# VERBOSE sent to stdout if _LOGGER_VERBOSE = true
# ALWAYS is sent to stdout unless _LOGGER_SILENT = true
# DEBUG & PARANOIA_DEBUG are only sent to stdout if _DEBUG=yes
# SIMPLE is a wrapper for QuickLogger that does not use advanced functionality
function Logger {
local value = " ${ 1 } " # Sentence to log (in double quotes)
local level = " ${ 2 } " # Log level
local retval = " ${ 3 :- undef } " # optional return value of command
if [ " $_LOGGER_PREFIX " = = "time" ] ; then
prefix = " TIME: $SECONDS - "
elif [ " $_LOGGER_PREFIX " = = "date" ] ; then
2018-09-30 13:56:00 +02:00
prefix = " $( date '+%Y-%m-%d %H:%M:%S' ) - "
2018-09-17 11:00:30 +02:00
else
prefix = ""
fi
## Obfuscate _REMOTE_TOKEN in logs (for ssh_filter usage only in osync and obackup)
value = " ${ value /env _REMOTE_TOKEN= $_REMOTE_TOKEN /__(o_O)__ } "
value = " ${ value /env _REMOTE_TOKEN= \$ _REMOTE_TOKEN /__(o_O)__ } "
if [ " $level " = = "CRITICAL" ] ; then
_Logger " $prefix ( $level ): $value " " $prefix \e[1;33;41m $value \e[0m " true
ERROR_ALERT = true
# ERROR_ALERT / WARN_ALERT is not set in main when Logger is called from a subprocess. Need to keep this flag.
echo -e " [ $retval ] in [ $( joinString , ${ FUNCNAME [@] } ) ] SP= $SCRIPT_PID P= $$ \n $prefix ( $level ): $value " >> " $RUN_DIR / $PROGRAM . ${ FUNCNAME [0] } .error. $SCRIPT_PID . $TSTAMP "
return
elif [ " $level " = = "ERROR" ] ; then
_Logger " $prefix ( $level ): $value " " $prefix \e[91m $value \e[0m " true
ERROR_ALERT = true
echo -e " [ $retval ] in [ $( joinString , ${ FUNCNAME [@] } ) ] SP= $SCRIPT_PID P= $$ \n $prefix ( $level ): $value " >> " $RUN_DIR / $PROGRAM . ${ FUNCNAME [0] } .error. $SCRIPT_PID . $TSTAMP "
return
elif [ " $level " = = "WARN" ] ; then
_Logger " $prefix ( $level ): $value " " $prefix \e[33m $value \e[0m " true
WARN_ALERT = true
echo -e " [ $retval ] in [ $( joinString , ${ FUNCNAME [@] } ) ] SP= $SCRIPT_PID P= $$ \n $prefix ( $level ): $value " >> " $RUN_DIR / $PROGRAM . ${ FUNCNAME [0] } .warn. $SCRIPT_PID . $TSTAMP "
return
elif [ " $level " = = "NOTICE" ] ; then
if [ " $_LOGGER_ERR_ONLY " != true ] ; then
_Logger " $prefix $value " " $prefix $value "
fi
return
elif [ " $level " = = "VERBOSE" ] ; then
if [ $_LOGGER_VERBOSE = = true ] ; then
_Logger " $prefix ( $level ): $value " " $prefix $value "
fi
return
elif [ " $level " = = "ALWAYS" ] ; then
_Logger " $prefix $value " " $prefix $value "
return
elif [ " $level " = = "DEBUG" ] ; then
if [ " $_DEBUG " = = "yes" ] ; then
_Logger " $prefix $value " " $prefix $value "
return
fi
elif [ " $level " = = "PARANOIA_DEBUG" ] ; then #__WITH_PARANOIA_DEBUG
if [ " $_PARANOIA_DEBUG " = = "yes" ] ; then #__WITH_PARANOIA_DEBUG
_Logger " $prefix $value " " $prefix \e[35m $value \e[0m " #__WITH_PARANOIA_DEBUG
return #__WITH_PARANOIA_DEBUG
fi #__WITH_PARANOIA_DEBUG
elif [ " $level " = = "SIMPLE" ] ; then
if [ " $_LOGGER_SILENT " = = true ] ; then
_Logger " $preix $value "
else
_Logger " $preix $value " " $prefix $value "
fi
return
else
_Logger " \e[41mLogger function called without proper loglevel [ $level ].\e[0m " " \e[41mLogger function called without proper loglevel [ $level ].\e[0m " true
_Logger " Value was: $prefix $value " " Value was: $prefix $value " true
fi
}
2018-07-30 15:36:53 +02:00
## Modified version of https://gist.github.com/cdown/1163649
2017-01-04 09:00:47 +01:00
function UrlEncode {
local length = " ${# 1 } "
2018-07-30 15:36:53 +02:00
local i
2017-01-04 09:00:47 +01:00
local LANG = C
2018-07-30 15:36:53 +02:00
for i in $( seq 0 $(( length-1)) ) ; do
2017-01-04 09:00:47 +01:00
local c = " ${ 1 : i : 1 } "
case $c in
[ a-zA-Z0-9.~_-] )
printf " $c "
; ;
*)
printf '%%%02X' " ' $c "
; ;
esac
done
2016-05-26 11:11:56 +02:00
}
2017-01-04 09:00:47 +01:00
function GetLocalOS {
2016-11-30 14:04:41 +01:00
local localOsVar
2017-03-14 22:31:15 +01:00
local localOsName
local localOsVer
2016-03-20 16:49:29 +01:00
2018-01-03 22:32:19 +01:00
# There is no good way to tell if currently running in BusyBox shell. Using sluggish way.
2017-01-04 09:00:47 +01:00
if ls --help 2>& 1 | grep -i "BusyBox" > /dev/null; then
localOsVar = "BusyBox"
else
# Detecting the special ubuntu userland in Windows 10 bash
if grep -i Microsoft /proc/sys/kernel/osrelease > /dev/null 2>& 1; then
localOsVar = "Microsoft"
else
localOsVar = " $( uname -spior 2>& 1) "
if [ $? != 0 ] ; then
localOsVar = " $( uname -v 2>& 1) "
if [ $? != 0 ] ; then
localOsVar = " $( uname) "
fi
fi
fi
fi
case $localOsVar in
# Android uname contains both linux and android, keep it before linux entry
*"Android" *)
LOCAL_OS = "Android"
; ;
*"Linux" *)
LOCAL_OS = "Linux"
; ;
*"BSD" *)
LOCAL_OS = "BSD"
; ;
2017-06-09 09:58:51 +02:00
*"MINGW32" *| *"MINGW64" *| *"MSYS" *)
2017-01-04 09:00:47 +01:00
LOCAL_OS = "msys"
; ;
*"CYGWIN" *)
LOCAL_OS = "Cygwin"
; ;
*"Microsoft" *)
LOCAL_OS = "WinNT10"
; ;
*"Darwin" *)
LOCAL_OS = "MacOSX"
; ;
*"BusyBox" *)
LOCAL_OS = "BusyBox"
; ;
*)
if [ " $IGNORE_OS_TYPE " = = "yes" ] ; then
Logger " Running on unknown local OS [ $localOsVar ]. " "WARN"
return
fi
if [ " $_OFUNCTIONS_VERSION " != "" ] ; then
Logger " Running on >> $localOsVar << not supported. Please report to the author. " "ERROR"
fi
exit 1
; ;
esac
2017-03-14 22:31:15 +01:00
# Get linux versions
if [ -f "/etc/os-release" ] ; then
2018-01-03 22:32:19 +01:00
localOsName = $( GetConfFileValue "/etc/os-release" "NAME" true )
localOsVer = $( GetConfFileValue "/etc/os-release" "VERSION" true )
2018-07-30 15:36:53 +02:00
elif [ " $LOCAL_OS " = = "BusyBox" ] ; then
localOsVer = ` ls --help 2>& 1 | head -1 | cut -f2 -d' ' `
localOsName = "BusyBox"
2017-03-14 22:31:15 +01:00
fi
2018-07-30 15:36:53 +02:00
# Get Host info for Windows
if [ " $LOCAL_OS " = = "msys" ] || [ " $LOCAL_OS " = = "BusyBox" ] || [ " $LOCAL_OS " = = "Cygwin" ] || [ " $LOCAL_OS " = = "WinNT10" ] ; then localOsVar = " $( uname -a) "
if [ " $PROGRAMW6432 " != "" ] ; then
LOCAL_OS_BITNESS = 64
LOCAL_OS_FAMILY = "Windows"
elif [ " $PROGRAMFILES " != "" ] ; then
LOCAL_OS_BITNESS = 32
LOCAL_OS_FAMILY = "Windows"
# Case where running on BusyBox but no program files defined
elif [ " $LOCAL_OS " = = "BusyBox" ] ; then
LOCAL_OS_FAMILY = "Unix"
fi
# Get Host info for Unix
else
LOCAL_OS_FAMILY = "Unix"
if uname -m | grep '64' > /dev/null 2>& 1; then
LOCAL_OS_BITNESS = 64
else
LOCAL_OS_BITNESS = 32
fi
fi
LOCAL_OS_FULL = " $localOsVar ( $localOsName $localOsVer ) $LOCAL_OS_BITNESS -bit $LOCAL_OS_FAMILY "
2017-06-09 09:58:51 +02:00
if [ " $_OFUNCTIONS_VERSION " != "" ] ; then
Logger " Local OS: [ $LOCAL_OS_FULL ]. " "DEBUG"
fi
2017-03-14 22:31:15 +01:00
}
function GetConfFileValue ( ) {
2018-02-24 17:41:57 +01:00
local file = " ${ 1 } "
local name = " ${ 2 } "
2018-01-03 22:32:19 +01:00
local noError = " ${ 3 :- false } "
2018-02-24 17:41:57 +01:00
local value
2017-03-14 22:31:15 +01:00
2018-02-24 17:41:57 +01:00
value = $( grep " ^ $name = " " $file " )
if [ $? = = 0 ] ; then
value = " ${ value ##*= } "
echo " $value "
else
2018-01-03 22:32:19 +01:00
if [ $noError = = true ] ; then
2018-02-24 17:41:57 +01:00
Logger " Cannot get value for [ $name ] in config file [ $file ]. " "NOTICE"
2018-01-03 22:32:19 +01:00
else
Logger " Cannot get value for [ $name ] in config file [ $file ]. " "ERROR"
fi
2018-02-24 17:41:57 +01:00
fi
2017-01-04 09:00:47 +01:00
}
2017-03-14 22:31:15 +01:00
2018-01-03 22:32:19 +01:00
2017-01-04 09:00:47 +01:00
function SetLocalOSSettings {
2016-11-30 14:04:41 +01:00
USER = root
2016-03-20 16:49:29 +01:00
2017-01-04 09:00:47 +01:00
# LOCAL_OS and LOCAL_OS_FULL are global variables set at GetLocalOS
2016-11-30 14:04:41 +01:00
2017-01-04 09:00:47 +01:00
case $LOCAL_OS in
2016-05-26 11:11:56 +02:00
*"BSD" *)
GROUP = wheel
; ;
2017-01-04 09:00:47 +01:00
*"MacOSX" *)
2016-05-26 11:11:56 +02:00
GROUP = admin
; ;
2017-01-04 09:00:47 +01:00
*"msys" *| *"Cygwin" *)
2016-05-26 11:11:56 +02:00
USER = ""
GROUP = ""
; ;
2016-09-08 22:51:24 +02:00
*)
GROUP = root
; ;
2016-05-26 11:11:56 +02:00
esac
2017-03-14 22:31:15 +01:00
if [ " $LOCAL_OS " = = "Android" ] || [ " $LOCAL_OS " = = "BusyBox" ] ; then
2018-09-17 11:00:30 +02:00
Logger " Cannot be installed on [ $LOCAL_OS ]. Please use $PROGRAM .sh directly. " "SIMPLE"
2017-01-04 09:00:47 +01:00
exit 1
fi
2016-09-08 22:51:24 +02:00
if ( [ " $USER " != "" ] && [ " $( whoami) " != " $USER " ] && [ " $FAKEROOT " = = "" ] ) ; then
2018-09-17 11:00:30 +02:00
Logger " Must be run as $USER . " "SIMPLE"
2016-05-26 11:11:56 +02:00
exit 1
2016-03-20 16:49:29 +01:00
fi
2015-11-12 01:26:38 +01:00
2017-01-04 09:00:47 +01:00
OS = $( UrlEncode " $LOCAL_OS_FULL " )
2016-05-26 11:11:56 +02:00
}
2016-05-25 19:54:47 +02:00
2016-05-26 11:11:56 +02:00
function GetInit {
2018-09-17 11:00:30 +02:00
if [ -f /sbin/openrc-run ] ; then
init = "openrc"
Logger "Detected openrc." "SIMPLE"
elif [ -f /sbin/init ] ; then
2016-05-26 11:11:56 +02:00
if file /sbin/init | grep systemd > /dev/null; then
init = "systemd"
2018-09-17 11:00:30 +02:00
Logger "Detected systemd." "SIMPLE"
2016-05-26 11:11:56 +02:00
else
init = "initV"
2018-09-17 11:00:30 +02:00
Logger "Detected initV." "SIMPLE"
2016-05-26 11:11:56 +02:00
fi
2016-04-08 21:09:00 +02:00
else
2018-09-17 11:00:30 +02:00
Logger " Can't detect initV, systemd or openRC. Service files won't be installed. You can still run $PROGRAM manually or via cron. " "SIMPLE"
2016-05-26 11:11:56 +02:00
init = "none"
2016-04-08 21:09:00 +02:00
fi
2016-05-26 11:11:56 +02:00
}
2017-03-14 22:31:15 +01:00
function CreateDir {
local dir = " ${ 1 } "
if [ ! -d " $dir " ] ; then
2018-07-30 15:36:53 +02:00
mkdir -p " $dir "
2016-05-26 11:11:56 +02:00
if [ $? = = 0 ] ; then
2018-09-17 11:00:30 +02:00
Logger " Created directory [ $dir ]. " "SIMPLE"
2016-05-26 11:11:56 +02:00
else
2018-09-17 11:00:30 +02:00
Logger " Cannot create directory [ $dir ]. " "SIMPLE"
2016-05-26 11:11:56 +02:00
exit 1
fi
2016-04-08 21:09:00 +02:00
fi
2016-05-26 11:11:56 +02:00
}
2016-04-08 21:09:00 +02:00
2017-03-14 22:31:15 +01:00
function CopyFile {
local sourcePath = " ${ 1 } "
local destPath = " ${ 2 } "
2018-09-17 11:00:30 +02:00
local sourceFileName = " ${ 3 } "
local destFileName = " ${ 4 } "
local fileMod = " ${ 5 } "
local fileUser = " ${ 6 } "
local fileGroup = " ${ 7 } "
local overwrite = " ${ 8 :- false } "
2017-03-14 22:31:15 +01:00
local userGroup = ""
local oldFileName
2018-09-17 11:00:30 +02:00
if [ " $destFileName " = = "" ] ; then
destFileName = " $sourceFileName "
2016-05-26 11:11:56 +02:00
fi
2018-09-17 11:00:30 +02:00
if [ -f " $destPath / $destFileName " ] && [ $overwrite = = false ] ; then
destfileName = " $sourceFileName .new "
Logger " Copying [ $sourceFileName ] to [ $destPath / $destFilename ]. " "SIMPLE"
fi
cp " $sourcePath / $sourceFileName " " $destPath / $destFileName "
2017-03-14 22:31:15 +01:00
if [ $? != 0 ] ; then
2018-09-17 11:00:30 +02:00
Logger " Cannot copy [ $sourcePath / $sourceFileName ] to [ $destPath / $destFileName ]. Make sure to run install script in the directory containing all other files. " "SIMPLE"
Logger " Also make sure you have permissions to write to [ $BIN_DIR ]. " "SIMPLE"
2017-03-14 22:31:15 +01:00
exit 1
else
2018-09-17 11:00:30 +02:00
Logger " Copied [ $sourcePath / $sourceFileName ] to [ $destPath / $destFileName ]. " "SIMPLE"
2017-03-14 22:31:15 +01:00
if [ " $fileMod " != "" ] ; then
2018-09-17 11:00:30 +02:00
chmod " $fileMod " " $destPath / $destFileName "
2017-03-14 22:31:15 +01:00
if [ $? != 0 ] ; then
2018-09-17 11:00:30 +02:00
Logger " Cannot set file permissions of [ $destPath / $destFileName ] to [ $fileMod ]. " "SIMPLE"
2017-03-14 22:31:15 +01:00
exit 1
else
2018-09-17 11:00:30 +02:00
Logger " Set file permissions to [ $fileMod ] on [ $destPath / $destFileName ]. " "SIMPLE"
2017-03-14 22:31:15 +01:00
fi
fi
2016-05-26 11:11:56 +02:00
2017-03-14 22:31:15 +01:00
if [ " $fileUser " != "" ] ; then
userGroup = " $fileUser "
2016-05-26 11:11:56 +02:00
2017-03-14 22:31:15 +01:00
if [ " $fileGroup " != "" ] ; then
userGroup = " $userGroup " " : $fileGroup "
fi
2016-09-08 22:51:24 +02:00
2018-09-17 11:00:30 +02:00
chown " $userGroup " " $destPath / $destFileName "
2017-03-14 22:31:15 +01:00
if [ $? != 0 ] ; then
2018-09-17 11:00:30 +02:00
Logger " Could not set file ownership on [ $destPath / $destFileName ] to [ $userGroup ]. " "SIMPLE"
2017-03-14 22:31:15 +01:00
exit 1
else
2018-09-17 11:00:30 +02:00
Logger " Set file ownership on [ $destPath / $destFileName ] to [ $userGroup ]. " "SIMPLE"
2017-03-14 22:31:15 +01:00
fi
2016-09-08 22:51:24 +02:00
fi
2016-04-08 21:09:00 +02:00
fi
2016-05-26 11:11:56 +02:00
}
2017-03-14 22:31:15 +01:00
function CopyExampleFiles {
exampleFiles = ( )
exampleFiles[ 0] = "sync.conf.example" # osync
exampleFiles[ 1] = "host_backup.conf.example" # obackup
exampleFiles[ 2] = "exclude.list.example" # osync & obackup
exampleFiles[ 3] = "snapshot.conf.example" # zsnap
exampleFiles[ 4] = "default.conf" # pmocr
for file in " ${ exampleFiles [@] } " ; do
if [ -f " $SCRIPT_PATH / $file " ] ; then
2018-09-17 11:00:30 +02:00
CopyFile " $SCRIPT_PATH " " $CONF_DIR " " $file " " $file " "" "" "" false
2017-03-14 22:31:15 +01:00
fi
done
}
2016-05-26 11:11:56 +02:00
function CopyProgram {
2017-03-14 22:31:15 +01:00
binFiles = ( )
binFiles[ 0] = " $PROGRAM_BINARY "
if [ " $PROGRAM " = = "osync" ] || [ " $PROGRAM " = = "obackup" ] ; then
binFiles[ 1] = " $PROGRAM_BATCH "
binFiles[ 2] = " $SSH_FILTER "
2015-11-12 01:26:38 +01:00
fi
2016-03-25 22:51:26 +01:00
2017-03-14 22:31:15 +01:00
local user = ""
local group = ""
2016-03-25 22:51:26 +01:00
2017-03-14 22:31:15 +01:00
if ( [ " $USER " != "" ] && [ " $FAKEROOT " = = "" ] ) ; then
user = " $USER "
2016-05-26 11:11:56 +02:00
fi
2017-03-14 22:31:15 +01:00
if ( [ " $GROUP " != "" ] && [ " $FAKEROOT " = = "" ] ) ; then
group = " $GROUP "
fi
for file in " ${ binFiles [@] } " ; do
2018-09-17 11:00:30 +02:00
CopyFile " $SCRIPT_PATH " " $BIN_DIR " " $file " " $file " 755 " $user " " $group " true
2017-03-14 22:31:15 +01:00
done
2016-05-26 11:11:56 +02:00
}
function CopyServiceFiles {
2017-03-14 22:31:15 +01:00
if ( [ " $init " = = "systemd" ] && [ -f " $SCRIPT_PATH / $SERVICE_FILE_SYSTEMD_SYSTEM " ] ) ; then
2018-07-30 15:36:53 +02:00
CreateDir " $SERVICE_DIR_SYSTEMD_SYSTEM "
2018-09-17 11:00:30 +02:00
CopyFile " $SCRIPT_PATH " " $SERVICE_DIR_SYSTEMD_SYSTEM " " $SERVICE_FILE_SYSTEMD_SYSTEM " " $SERVICE_FILE_SYSTEMD_SYSTEM " "" "" "" true
2018-07-30 15:36:53 +02:00
if [ -f " $SCRIPT_PATH / $SERVICE_FILE_SYSTEMD_USER " ] ; then
CreateDir " $SERVICE_DIR_SYSTEMD_USER "
2018-09-17 11:00:30 +02:00
CopyFile " $SCRIPT_PATH " " $SERVICE_DIR_SYSTEMD_USER " " $SERVICE_FILE_SYSTEMD_USER " " $SERVICE_FILE_SYSTEMD_USER " "" "" "" true
2017-06-09 09:58:51 +02:00
fi
2018-09-17 11:00:30 +02:00
Logger " Created [ $SERVICE_NAME ] service in [ $SERVICE_DIR_SYSTEMD_SYSTEM ] and [ $SERVICE_DIR_SYSTEMD_USER ]. " "SIMPLE"
Logger " Can be activated with [systemctl start SERVICE_NAME@instance.conf] where instance.conf is the name of the config file in $CONF_DIR . " "SIMPLE"
Logger " Can be enabled on boot with [systemctl enable $SERVICE_NAME @instance.conf]. " "SIMPLE"
Logger " In userland, active with [systemctl --user start $SERVICE_NAME @instance.conf]. " "SIMPLE"
2017-03-14 22:31:15 +01:00
elif ( [ " $init " = = "initV" ] && [ -f " $SCRIPT_PATH / $SERVICE_FILE_INIT " ] && [ -d " $SERVICE_DIR_INIT " ] ) ; then
2018-09-17 11:00:30 +02:00
#CreateDir "$SERVICE_DIR_INIT"
CopyFile " $SCRIPT_PATH " " $SERVICE_DIR_INIT " " $SERVICE_FILE_INIT " " $SERVICE_FILE_INIT " "755" "" "" true
Logger " Created [ $SERVICE_NAME ] service in [ $SERVICE_DIR_INIT ]. " "SIMPLE"
Logger " Can be activated with [service $SERVICE_FILE_INIT start]. " "SIMPLE"
Logger " Can be enabled on boot with [chkconfig $SERVICE_FILE_INIT on]. " "SIMPLE"
elif ( [ " $init " = = "openrc" ] && [ -f " $SCRIPT_PATH / $SERVICE_FILE_OPENRC " ] && [ -d " $SERVICE_DIR_OPENRC " ] ) ; then
# Rename service to usual service file
CopyFile " $SCRIPT_PATH " " $SERVICE_DIR_OPENRC " " $SERVICE_FILE_OPENRC " " $SERVICE_FILE_INIT " "755" "" "" true
Logger " Created [ $SERVICE_NAME ] service in [ $SERVICE_DIR_OPENRC ]. " "SIMPLE"
Logger " Can be activated with [rc-update add $SERVICE_NAME .instance] where instance is a configuration file found in /etc/osync. " "SIMPLE"
2017-03-14 22:31:15 +01:00
else
2018-09-17 11:00:30 +02:00
Logger "Cannot properly find how to deal with init on this system. Skipping service file installation." "SIMPLE"
2016-05-26 11:11:56 +02:00
fi
}
function Statistics {
2017-01-04 09:00:47 +01:00
if type wget > /dev/null; then
wget -qO- " $STATS_LINK " > /dev/null 2>& 1
if [ $? = = 0 ] ; then
return 0
fi
2016-03-25 22:51:26 +01:00
fi
2016-04-08 21:09:00 +02:00
2017-01-04 09:00:47 +01:00
if type curl > /dev/null; then
curl " $STATS_LINK " -o /dev/null > /dev/null 2>& 1
if [ $? = = 0 ] ; then
return 0
fi
2016-04-08 21:09:00 +02:00
fi
2018-09-17 11:00:30 +02:00
Logger "Neiter wget nor curl could be used for. Cannot run statistics. Use the provided link please." "SIMPLE"
2017-01-04 09:00:47 +01:00
return 1
2016-05-26 11:11:56 +02:00
}
2017-03-14 22:31:15 +01:00
function RemoveFile {
local file = " ${ 1 } "
if [ -f " $file " ] ; then
rm -f " $file "
if [ $? != 0 ] ; then
2018-09-17 11:00:30 +02:00
Logger " Could not remove file [ $file ]. " "SIMPLE"
2017-03-14 22:31:15 +01:00
else
2018-09-17 11:00:30 +02:00
Logger " Removed file [ $file ]. " "SIMPLE"
2017-03-14 22:31:15 +01:00
fi
else
2018-09-17 11:00:30 +02:00
Logger " File [ $file ] not found. Skipping. " "SIMPLE"
2017-03-14 22:31:15 +01:00
fi
}
function RemoveAll {
RemoveFile " $BIN_DIR / $PROGRAM_BINARY "
2017-06-09 09:58:51 +02:00
if [ " $PROGRAM " = = "osync" ] || [ " $PROGRAM " = = "obackup" ] ; then
RemoveFile " $BIN_DIR / $PROGRAM_BATCH "
fi
2017-03-14 22:31:15 +01:00
if [ ! -f " $BIN_DIR /osync.sh " ] && [ ! -f " $BIN_DIR /obackup.sh " ] ; then # Check if any other program requiring ssh filter is present before removal
RemoveFile " $BIN_DIR / $SSH_FILTER "
else
2018-09-17 11:00:30 +02:00
Logger " Skipping removal of [ $BIN_DIR / $SSH_FILTER ] because other programs present that need it. " "SIMPLE"
2017-03-14 22:31:15 +01:00
fi
RemoveFile " $SERVICE_DIR_SYSTEMD_SYSTEM / $SERVICE_FILE_SYSTEMD_SYSTEM "
2018-07-30 15:36:53 +02:00
RemoveFile " $SERVICE_DIR_SYSTEMD_USER / $SERVICE_FILE_SYSTEMD_USER "
2017-03-14 22:31:15 +01:00
RemoveFile " $SERVICE_DIR_INIT / $SERVICE_FILE_INIT "
2018-09-17 11:00:30 +02:00
Logger " Skipping configuration files in [ $CONF_DIR ]. You may remove this directory manually. " "SIMPLE"
2017-03-14 22:31:15 +01:00
}
2016-05-26 11:11:56 +02:00
function Usage {
echo " Installs $PROGRAM into $BIN_DIR "
echo "options:"
echo "--silent Will log and bypass user interaction."
echo "--no-stats Used with --silent in order to refuse sending anonymous install stats."
2017-06-09 09:58:51 +02:00
echo "--remove Remove the program."
2018-07-30 15:36:53 +02:00
echo "--prefix=/path Use prefix to install path."
2016-05-26 11:11:56 +02:00
exit 127
2016-03-25 22:51:26 +01:00
}
2018-09-17 11:00:30 +02:00
############################## Script entry point
if [ " $LOGFILE " = = "" ] ; then
if [ -w /var/log ] ; then
LOG_FILE = " /var/log/ $PROGRAM . $INSTANCE_ID .log "
elif ( [ " $HOME " != "" ] && [ -w " $HOME " ] ) ; then
LOG_FILE = " $HOME / $PROGRAM . $INSTANCE_ID .log "
else
LOG_FILE = " ./ $PROGRAM . $INSTANCE_ID .log "
fi
else
LOG_FILE = " $LOGFILE "
fi
if [ ! -w " $( dirname $LOG_FILE ) " ] ; then
echo " Cannot write to log [ $( dirname $LOG_FILE ) ]. "
else
Logger " Script begin, logging to [ $LOG_FILE ]. " "DEBUG"
fi
2017-01-04 09:00:47 +01:00
GetLocalOS
SetLocalOSSettings
2016-05-26 11:11:56 +02:00
GetInit
2017-03-14 22:31:15 +01:00
STATS_LINK = " http://instcount.netpower.fr?program= $PROGRAM &version= $PROGRAM_VERSION &os= $OS &action= $ACTION "
if [ " $ACTION " = = "uninstall" ] ; then
RemoveAll
2018-09-17 11:00:30 +02:00
Logger " $PROGRAM uninstalled. " "SIMPLE"
2017-03-14 22:31:15 +01:00
else
CreateDir " $CONF_DIR "
CreateDir " $BIN_DIR "
CopyExampleFiles
CopyProgram
2017-06-09 09:58:51 +02:00
if [ " $PROGRAM " = = "osync" ] || [ " $PROGRAM " = = "pmocr" ] ; then
CopyServiceFiles
fi
2018-09-17 11:00:30 +02:00
Logger " $PROGRAM installed. Use with $BIN_DIR / $PROGRAM " "SIMPLE"
2017-03-14 22:31:15 +01:00
if [ " $PROGRAM " = = "osync" ] || [ " $PROGRAM " = = "obackup" ] ; then
2018-09-17 11:00:30 +02:00
echo ""
Logger "If connecting remotely, consider setup ssh filter to enhance security." "SIMPLE"
echo ""
2017-03-14 22:31:15 +01:00
fi
fi
2016-05-26 11:11:56 +02:00
if [ $_STATS -eq 1 ] ; then
2017-01-04 09:00:47 +01:00
if [ $_LOGGER_SILENT = = true ] ; then
2016-05-26 11:11:56 +02:00
Statistics
else
2018-09-17 11:00:30 +02:00
Logger " In order to make usage statistics, the script would like to connect to $STATS_LINK " "SIMPLE"
2017-03-14 22:31:15 +01:00
read -r -p "No data except those in the url will be send. Allow [Y/n] " response
2016-05-26 11:11:56 +02:00
case $response in
[ nN] )
exit
; ;
*)
Statistics
exit $?
; ;
esac
fi
fi